// CDATABASE64.H

#if !defined ( _CDATABASE64_H_ )


#define _CDATABASE64_H_


#define DB64_WHITE		0

// Database encoding 
#define DB64_LOSE		0
#define DB64_WIN		1
#define DB64_DRAW		2
#define DB64_UNKNOWN	3

#define DB64_MAXTESTPOSITIONS	262144
#define DB64_MINTESTPOSITIONS	200000
#define DB64_TESTFILE			"DB64TestPos.txt"
#define DB64_INFOFILE			"DB64Info.dat"
#define DB64_INDEXFILE			"DB64Index.dat"
#define DB64_INDEXNAME			"DB64Index"
#define DB64_INDEXEXT			".dat"

#define	DB64_COMPRESS_X			0
#define DB64_COMPRESS_Y			1
#define DB64_COMPRESS_DEFAULT	1

// Cache encodings
#define DB64CACHE_BLOCKNUMBER		1048576
#define DB64CACHE_BLOCKSIZE			4096
#define DB64CACHE_BLOCKBITS			12
#define DB64CACHE_MAXPIECE			7

#define DB64CACHE_ILLEGALINDEX		-1
#define DB64CACHE_ILLEGALBLOCK		-1
#define DB64CACHE_BLOCK_NOTLOADED	-1
#define DB64CACHE_READ_ERROR		-2


class CDatabase64
{

public:

	CDatabase64() ;
	~CDatabase64() ;

	CString m_csDatabasePath ;

	int m_cix[64], m_cxi[51] ;
	int m_iWhiteSlice[64], m_iBlackSlice[64] ;
	__int64 iIndex[6][64] ;

	CRITICAL_SECTION	m_DB64Lock ;

	// Database Cache
	DB64CACHE DB64Cache ;

	void	Database64_Init(void) ;
	DBINDEX BinomialCoefficient(int, int) ;
	void	Init_Index64(void) ;

	DBINDEX Index64(PTSTACK) ;
	
	char	*cDatabaseName(int, int, int, int, int, int) ;

	void	DB64_Init(PENGINEDATA) ;

	int		DatabaseID(int, int, int, int, int, int, int) ;
	int		DatabaseID(PTSTACK) ;

	void	SendEngineMessage(int, PENGINEDATA, int, CString) ;

	// Cache Functions
	bool	DB64Cache_FENRead(char*, PDB64POSITION) ;
	int		DB64Cache_TestRead(PDB64POSITION) ;
	bool	DB64Cache_Test(PENGINEDATA, int) ;
	bool	DB64Cache_Open(int) ;
	bool	DB64Cache_Close(void) ;
	bool	DB64Cache_Clear(PENGINEDATA) ;
	bool	DB64Cache_Init(PENGINEDATA) ;
	bool	DB64Cache_Modify(PENGINEDATA) ;
	__int64	DB64Cache_ReadBlock(int, DBINDEX) ;
	int		DB64Cache_Read(int, DBINDEX) ;
	int		DB64Cache_Read(PTSTACK, int) ;
	bool	DB64Cache_ReadDataIndex(int) ;
	int		DB64Cache_ReadCPRValue(unsigned char*, DBINDEX) ;

	// Database Evaluation Functions
	bool	DatabasePosition0(PTSTACK, int*) ;
	bool	DatabasePosition(bool, PTSTACK, int*) ;
	int		DatabasePositionDB64(PTSTACK) ;

} ;

#endif	// _CDATABASE64_H_